## libfiu 1.2

=== Makefile ===


default: all

install: all_install

uninstall: all_uninstall

all: libfiu preload utils

all_install: libfiu_install preload_install utils_install

all_uninstall: libfiu_uninstall preload_uninstall utils_uninstall


libfiu:
	$(MAKE) -C libfiu

libfiu_clean:
	$(MAKE) -C libfiu clean

libfiu_install:
	$(MAKE) -C libfiu install

libfiu_uninstall:
	$(MAKE) -C libfiu uninstall


preload: libfiu
	$(MAKE) -C preload

preload_clean:
	$(MAKE) -C preload clean

preload_install: preload
	$(MAKE) -C preload install

preload_uninstall:
	$(MAKE) -C preload uninstall


utils:
	$(MAKE) -C utils

utils_clean:
	$(MAKE) -C utils clean

utils_install: utils
	$(MAKE) -C utils install

utils_uninstall:
	$(MAKE) -C utils uninstall


tests: test

test: libfiu bindings preload
	$(MAKE) -C tests

test_clean:
	$(MAKE) -C tests clean


bindings: python3

bindings_install: python3_install

bindings_clean: python_clean

python3: libfiu
	cd bindings/python && python3 setup.py build

python3_install: python3
	cd bindings/python && python3 setup.py install

python_clean:
	cd bindings/python && rm -rf build/ fiu_ctrl.py


clean: python_clean preload_clean libfiu_clean utils_clean test_clean


# Auto-format code with an uniform style.
# Most preload/posix files are not auto-formatted because of the crazy code
# generation macros.
format:
	clang-format -i \
		`find bindings/ libfiu/ tests/ preload/run/ \
			-iname '*.[ch]'` \
		preload/posix/codegen.c
	black -q -l 79 bindings/python/*.py tests/*.py


.PHONY: default all clean install all_install uninstall all_uninstall \
	libfiu libfiu_clean libfiu_install libfiu_uninstall \
	python3 python3_install python_clean \
	bindings bindings_install bindings_clean \
	preload preload_clean preload_install preload_uninstall \
	utils utils_clean utils_install utils_uninstall \
	test tests test_clean \
	format

=== libfiu/Makefile ===

CFLAGS += -std=c99 -pedantic -Wall
ALL_CFLAGS = -D_XOPEN_SOURCE=600 -fPIC -DFIU_ENABLE=1 \
		$(CFLAGS) $(CPPFLAGS) $(LDFLAGS)

# Optimization CFLAGS, only used when doing a non-debug build.
OPT_CFLAGS = -O3

ifdef DEBUG
    ALL_CFLAGS += -g
else
   ifdef PROFILE
        ALL_CFLAGS += -g -pg -fprofile-arcs -ftest-coverage
   else
       ALL_CFLAGS += $(OPT_CFLAGS)
   endif
endif

ifdef TRACE
    ALL_CFLAGS += -DFIU_TRACE=1
endif

# prefix for installing the binaries
PREFIX=/usr/local

# prefix for eventual location of binaries
DESTDIR=$(PREFIX)

# install utility, we assume it's GNU/BSD compatible
INSTALL=install


OBJS = fiu.o fiu-rc.o backtrace.o wtable.o hash.o


ifneq ($(V), 1)
	NICE_CC = @echo "  CC  $@"; $(CC)
else
	NICE_CC = $(CC)
endif

LIB_VER=1.2
LIB_SO_VER=0


# We attempt to detect if we have the extensions we use in backtrace.c by just
# attempting to compile it normally, and fall back to the dummy version if
# that fails. Not very sophisticated but should be safe.
USE_DUMMY_BACKTRACE := $(shell $(CC) $(ALL_CFLAGS) -c backtrace.c \
	-o backtrace-check.o || echo -DDUMMY_BACKTRACE)
ifndef USE_DUMMY_BACKTRACE
# The real backtrace needs linking against libdl.
USE_LIBDL = -ldl
endif


default: all

all: libs libfiu.pc

libfiu.pc: build-flags libfiu.pc.in
	@echo "generating libfiu.pc"
	@cat libfiu.pc.in | \
		sed 's@++DESTDIR++@$(DESTDIR)@g' | \
		sed 's@++LIB_VER++@$(LIB_VER)@g' \
		> libfiu.pc

libs: libfiu.so libfiu.a

libfiu.so: build-flags symbols.map fiu.h $(OBJS)
	$(NICE_CC) $(ALL_CFLAGS) -shared -fPIC \
		-Wl,-soname,libfiu.so.$(LIB_SO_VER) \
		-Wl,--version-script=symbols.map \
		$(OBJS) -lpthread $(USE_LIBDL) -o libfiu.so.$(LIB_VER)
	ln -fs libfiu.so.$(LIB_VER) libfiu.so
	ln -fs libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER)

libfiu.a: build-flags fiu.h $(OBJS)
	$(AR) cr libfiu.a $(OBJS)


install-lib: libs libfiu.pc
	$(INSTALL) -d $(PREFIX)/lib
	$(INSTALL) -m 0755 libfiu.so.$(LIB_VER) $(PREFIX)/lib
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so
	ln -fs libfiu.so.$(LIB_VER) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(INSTALL) -m 0755 libfiu.a $(PREFIX)/lib
	$(INSTALL) -d $(PREFIX)/include
	$(INSTALL) -m 0644 fiu.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-control.h $(PREFIX)/include
	$(INSTALL) -m 0644 fiu-local.h $(PREFIX)/include
	$(INSTALL) -d $(PREFIX)/lib/pkgconfig
	$(INSTALL) -m 644 libfiu.pc $(PREFIX)/lib/pkgconfig
	@echo
	@echo "Please run ldconfig to update your library cache"
	@echo

install-man:
	$(INSTALL) -d $(PREFIX)/share/man/man3
	$(INSTALL) -m 0644 libfiu.3 $(PREFIX)/share/man/man3/

install: install-lib install-man

uninstall-lib:
	$(RM) $(PREFIX)/lib/libfiu.so
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_VER)
	$(RM) $(PREFIX)/lib/libfiu.so.$(LIB_SO_VER)
	$(RM) $(PREFIX)/lib/libfiu.a
	$(RM) $(PREFIX)/include/fiu.h
	$(RM) $(PREFIX)/include/fiu-control.h
	$(RM) $(PREFIX)/include/fiu-local.h
	$(RM) $(PREFIX)/lib/pkgconfig/libfiu.pc

uninstall-man:
	$(RM) $(PREFIX)/share/man/man3/libfiu.3

uninstall: uninstall-lib uninstall-man


BF = $(ALL_CFLAGS) ~ $(PREFIX)
build-flags: .force-build-flags
	@if [ x"$(BF)" != x"`cat build-flags 2>/dev/null`" ]; then \
		if [ -f build-flags ]; then \
			echo "build flags changed, rebuilding"; \
		fi; \
		echo "$(BF)" > build-flags; \
	fi


$(OBJS): build-flags

.c.o:
	$(NICE_CC) $(ALL_CFLAGS) -c $< -o $@

backtrace.o: ALL_CFLAGS += $(USE_DUMMY_BACKTRACE)


doxygen:
	        $(MAKE) LIB_VER=$(LIB_VER) -C doxygen


clean:
	rm -f libfiu.pc $(OBJS) backtrace-check.o
	rm -f libfiu.so libfiu.so.$(LIB_VER) libfiu.so.$(LIB_SO_VER) libfiu.a
	rm -f *.bb *.bbg *.da *.gcov *.gcda *.gcno gmon.out build-flags
	$(MAKE) -C doxygen $@

.PHONY: default all libs \
	install-lib install-man install \
	uninstall-lib uninstall-man uninstall \
	doxygen clean \
	.force-build-flags

=== preload/Makefile ===

default: all

all: posix run

install: posix_install run_install

uninstall: posix_uninstall run_uninstall

clean: posix_clean run_clean


posix:
	$(MAKE) -C posix/

posix_clean:
	$(MAKE) -C posix/ clean

posix_install:
	$(MAKE) -C posix/ install

posix_uninstall:
	$(MAKE) -C posix/ uninstall

run:
	$(MAKE) -C run/

run_clean:
	$(MAKE) -C run/ clean

run_install:
	$(MAKE) -C run/ install

run_uninstall:
	$(MAKE) -C run/ uninstall


.PHONY: default clean install uninstall\
	posix posix_clean posix_install posix_uninstall \
	run run_clean run_install run_uninstall

=== debian/changelog ===
libfiu (1.2-4build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 13:23:10 +0000

libfiu (1.2-4) unstable; urgency=medium

  * Apply an upstream patch to fix FTBFS with GCC-15. (Closes: #1097184)

 -- Chris Lamb <lamby@debian.org>  Tue, 09 Sep 2025 17:05:31 -0700

libfiu (1.2-3) unstable; urgency=medium

  * Add explicit Build-Depends on python3-setuptools. (Closes: #1080632)
  * Bump Standards-Version to 4.7.0.

 -- Chris Lamb <lamby@debian.org>  Fri, 06 Sep 2024 12:36:56 +0100

libfiu (1.2-2) unstable; urgency=medium

  * Drop python3-distutils from Build-Depends. (Closes: #1065891)

 -- Chris Lamb <lamby@debian.org>  Mon, 11 Mar 2024 18:32:39 +0000

libfiu (1.2-1) unstable; urgency=medium

  * New upstream release.
    - Drop all local patches; applied upstream.

 -- Chris Lamb <lamby@debian.org>  Sat, 04 Nov 2023 10:18:26 +0100

libfiu (1.1-5) unstable; urgency=medium

  * Backport a patch (5dcc6d4) from upstream in order to fix test failure.
    (Closes: #1054777)
  * Bump Standards-Version to 4.6.2.

 -- Chris Lamb <lamby@debian.org>  Sun, 29 Oct 2023 12:11:33 +0000

libfiu (1.1-4) unstable; urgency=medium

  * Use dh_auto_clean to ensure package is properly cleaned. (Closes: #1048082)

 -- Chris Lamb <lamby@debian.org>  Tue, 22 Aug 2023 13:36:37 -0700

=== debian/control ===
Source: libfiu
Section: libs
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-python,
 libpython3-all-dev,
 python3-all-dev:any,
 python3-docutils,
 python3-setuptools,
Standards-Version: 4.7.0
Homepage: https://blitiri.com.ar/p/libfiu/
Vcs-Git: https://salsa.debian.org/lamby/pkg-libfiu.git
Vcs-Browser: https://salsa.debian.org/lamby/pkg-libfiu
Rules-Requires-Root: no

Package: libfiu0
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: userspace fault injection framework
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the libfiu shared library. To perform fault injection,
 you will require the "libfiu-dev" package.

Package: fiu-utils
Section: devel
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: userspace fault injection framework (utilities)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the fiu-run, fiu-ls and fiu-ctrl utilities.

Package: libfiu-dev
Section: libdevel
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: userspace fault injection framework (development libraries)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains the development libraries and documentation in HTML and
 reStructuredText formats.

Package: python3-fiu
Section: python
Architecture: any
Depends:
 libfiu0 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: userspace fault injection framework (Python 3 bindings)
 libfiu is a C library for fault injection. It provides functions to mark
 "points of failure" inside your code (the "core API"), and functions to
 enable/disable the failure of those points (the "control API").
 .
 This package contains Python 3 bindings to libfiu.

=== debian/rules ===
#!/usr/bin/make -f

DOCS = $(patsubst %.rst,%.html, $(wildcard doc/*.rst))
PYTHON_VERSIONS := $(shell py3versions -sv)
PYTHON_VERSION_DEFAULT := $(shell py3versions -dv)
DPKG_EXPORT_BUILDFLAGS = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk

%:
	dh $@ --with python3

override_dh_auto_clean:
	dh_auto_clean
	rm -f doc/*.html

doc/%.html: doc/%.rst
	rst2html $< > $@

override_dh_auto_build: $(DOCS)
	dh_auto_build -- V=1 $(shell dpkg-buildflags --export=cmdline)
	cd bindings/python && \
	set -e && for i in $(PYTHON_VERSIONS); do \
		python$$i ./setup.py build; \
	done

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	find bindings/python/build \
		-maxdepth 1 \
		-type d \
		-not -name '*$(PYTHON_VERSION_DEFAULT)*' -print0 | \
		xargs -0r rm -rvf
	# Remove non-deterministic tests
	rm -fv tests/test-parallel.c tests/test-parallel-wildcard.c
	dh_auto_test -- V=1 LC_ALL=C
endif

override_dh_auto_install:
	make install PREFIX=$(CURDIR)/debian/tmp/usr DESTDIR=/usr PLIBPATH=/usr/lib/fiu V=1
	cd bindings/python && \
	set -e && for i in $(PYTHON_VERSIONS); do \
		python$$i ./setup.py install --root=$(CURDIR)/debian/python3-fiu --no-compile -O0 --install-layout=deb; \
	done

override_dh_compress:
	dh_compress -X.rst
